# Workaround for the problem of /usr/bin/strip not handling PE binaries.
%define __spec_install_post %{nil}

%define runtime     mingw-runtime
%define w32api_pkg  mingw-w32api
%define w32api      w32api

%define packageVer 3.14
%define runtimeVer 3.14
%define w32apiVer 3.11

%define target i386-mingw32
%define prefix /usr/local/%{target}

# Don't build debuginfo packages
%define debug_package %{nil}

Summary:   MinGW environment on Linux
Name:      mingw
Version:   %{packageVer}
Release:   23hl
License:   Distributable
Packager:  Hans Leidekker <hans@it.vu.nl>
Vendor:    Hans Leidekker <hans@it.vu.nl>

Group:     Development/Libraries
URL:       http://sourceforge.net/projects/mingw
Source0:   http://prdownloads.sourceforge.net/mingw/%{runtime}-%{runtimeVer}-src.tar.gz
Source1:   http://prdownloads.sourceforge.net/mingw/%{w32api}-%{w32apiVer}-src.tar.gz

Patch0:    w32api_lib_advpack_def.patch.gz
Patch1:    w32api_lib_urlmon_def.patch.gz
Patch2:    w32api_lib_gdiplus_def01.patch.gz
Patch3:    w32api_lib_pdh_def01.patch.gz
Patch4:    w32api_lib_ole32_def.patch.gz
Patch5:    w32api_lib_crypt32_def.patch.gz
Patch6:    w32api_lib_msi_def.patch.gz
Patch7:    w32api_lib_rpcrt4_def01.patch.gz
Patch8:    w32api_lib_directx_dxguid_c_02.patch.gz
Patch9:    w32api_lib_directx_dxguid_c_03.patch.gz
Patch10:   w32api_lib_shell32_def.patch.gz
Patch11:   w32api_lib_mshtml_uuid_c.patch.gz
Patch12:   w32api_lib_mshtml_uuid_c2.patch.gz
Patch13:   w32api_lib_gdi32_def.patch.gz
Patch14:   w32api_lib_crypt32_def3.patch.gz
Patch15:   w32api_lib_crypt32_def4.patch.gz
Patch16:   w32api_lib_secur32_def2.patch.gz
Patch17:   w32api_lib_crypt32_def5.patch.gz
Patch18:   w32api_lib_crypt32_def6.patch.gz
Patch19:   w32api_lib_crypt32_def7.patch.gz
Patch20:   w32api_lib_crypt32_def8.patch.gz
Patch21:   w32api_lib_crypt32_def9.patch.gz
Patch22:   w32api_lib_crypt32_defA.patch.gz
Patch23:   w32api_lib_mshtml_uuid_c4.patch.gz
Patch24:   w32api_lib_msi_def2.patch.gz
Patch25:   w32api_lib_shell32_c1.patch.gz
Patch26:   w32api_lib_msi_def3.patch.gz
Patch27:   w32api_lib_advapi32_def.patch.gz
Patch28:   w32api_lib_wintrust_def.patch.gz
Patch29:   w32api_lib_directx_d3dx8.patch.gz
Patch30:   w32api_lib_cabinet_def.patch.gz
Patch31:   w32api_lib_crypt32_defB.patch.gz
Patch32:   w32api_lib_crypt32_defC.patch.gz
Patch33:   w32api_lib_crypt32_defD.patch.gz
Patch34:   w32api_lib_inetcomm_def.patch.gz
Patch35:   w32api_lib_riched20_def.patch.gz
Patch36:   w32api_lib_credui_def.patch.gz
Patch37:   w32api_lib_crypt32_defE.patch.gz
Patch38:   w32api_lib_crypt32_defF.patch.gz
Patch39:   w32api_lib_crypt32_defG.patch.gz
Patch40:   w32api_lib_crypt32_defH.patch.gz
Patch41:   w32api_lib_crypt32_defI.patch.gz
Patch42:   w32api_lib_crypt32_defJ.patch.gz
Patch43:   w32api_lib_crypt32_defK.patch.gz
Patch44:   w32api_lib_ntdsapi_def.patch.gz
Patch45:   w32api_lib_crypt32_defM.patch.gz
Patch46:   w32api_lib_cryptnet_def.patch.gz
Patch47:   w32api_lib_mshtml_uuid_c5.patch.gz
Patch48:   w32api_lib_ole32_def1.patch.gz
Patch49:   w32api_lib_mshtml_uuid_c7.patch.gz
Patch50:   w32api_lib_mshtml_uuid_c8.patch.gz
Patch51:   w32api_lib_hlink_def.patch.gz
Patch52:   w32api_lib_crypt32_defO.patch.gz
Patch53:   w32api_lib_extras-uuid.patch.gz
Patch54:   w32api_lib_mlang-uuid.patch.gz
Patch55:   w32api_lib_mshtml-uuid.patch.gz
Patch56:   w32api_lib_oleidl-uuid.patch.gz
Patch57:   w32api_lib_oleidl-uuid_2.patch.gz
Patch58:   w32api_lib_mshtml-uuid_2.patch.gz
Patch59:   w32api_lib_urlmon-uuid.patch.gz
Patch60:   w32api_lib_objidl-uuid.patch.gz
Patch61:   w32api_lib_unknwn-uuid.patch.gz
Patch62:   w32api_lib_crypt32_defR.patch.gz
Patch63:   w32api_lib_msxml_uuid_c.patch.gz
Patch64:   w32api_lib_snmpapi_def.patch.gz
Patch65:   w32api_lib_mshtml_uuid_c9.patch.gz
Patch66:   w32api_lib_mshtml_uuid_c10.patch.gz
Patch67:   w32api_lib_mshtml_uuid_c11.patch.gz
Patch68:   w32api_lib_oleidl-uuid_3.patch.gz
Patch69:   w32api_lib_urlmon_uuid_c2.patch.gz

BuildPrereq: perl, mingw-binutils, mingw-gcc-core
Buildroot: %{_tmppath}/%{name}-root

%description
MinGW is a set of include files and import libraries that allow one to use GCC to build native Windows applications that use vendor-supplied runtime.

%package -n %{runtime}
Version: %{runtimeVer}
Summary: MinGW runtime library
Group:   Development/Libraries

%description -n %{runtime}
The MinGW runtime provides the prototypes and import library for the MSVCRT.DLL Microsoft supplied runtime library.  It includes extensions to the runtime supplied by mscvrt.dll in a static lib called libmingwex.a. These extensions include some C89 and C99 wide character functions, floating point environment functions (declared in fenv.h), floating point classification functions and macros, the inttypes.h format conversion macros, stubs for some mscvrt.dll underscored functions that are now part of C99 std, and a replacement for fseek and fwrite that are safer on W9x.

%package -n %{w32api_pkg}
Version:   %{w32apiVer}
Summary:   MinGW Win32 API
Group:     Development/Libraries
Obsoletes: w32api

%description -n %{w32api_pkg}
The w32api is the package of headers and import libraries to support the Win32 Application Programming Interface as created by Microsoft. The MinGW development team are the current maintainers of the w32api since without that package Windows Programming would not be possible. The package was created by Anders Norlander and it's license is also non-restrictive.

%prep
%setup -q -c -a 1
ln -s %{w32api}-%{w32apiVer} w32api
ln -s %{runtime}-%{runtimeVer} mingw
%patch0 -p0
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch14 -p0
%patch15 -p0
%patch16 -p0
%patch17 -p0
%patch18 -p0
%patch19 -p0
%patch20 -p0
%patch21 -p0
%patch22 -p0
%patch23 -p0
%patch24 -p0
%patch25 -p0
%patch26 -p0
%patch27 -p0
%patch28 -p0
%patch29 -p0
%patch30 -p0
%patch31 -p0
%patch32 -p0
%patch33 -p0
%patch34 -p0
%patch35 -p0
%patch36 -p0
%patch37 -p0
%patch38 -p0
%patch39 -p0
%patch40 -p0
%patch41 -p0
%patch42 -p0
%patch43 -p0
%patch44 -p0
%patch45 -p0
%patch46 -p0
%patch47 -p0
%patch48 -p0
%patch49 -p0
%patch50 -p0
%patch51 -p0
%patch52 -p0
%patch53 -p0
%patch54 -p0
%patch55 -p0
%patch56 -p0
%patch57 -p0
%patch58 -p0
%patch59 -p0
%patch60 -p0
%patch61 -p0
%patch62 -p0
%patch63 -p0
%patch64 -p0
%patch65 -p0
%patch66 -p0
%patch67 -p0
%patch68 -p0
%patch69 -p0

#==========================================
%build

export AR=%{target}-ar
export AS=%{target}-as
export CC=%{target}-gcc
export DLLTOOL=%{target}-dlltool
export LD=%{target}-ld
export RANLIB=%{target}-ranlib
export WINDRES=%{target}-windres

#------------------------------------------
# Win32 API
#
cd %{w32api}-%{w32apiVer}
./configure --prefix=%{prefix} --target=%{target} --build=%{target} -v
make
cd ..

#------------------------------------------
# Runtime
#
cd %{runtime}-%{runtimeVer}
./configure --prefix=%{prefix} --target=%{target} --host=%{target} -v
#cd mingwex
#make
make
cd ..

#==========================================
%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}
rm -f *.files

#------------------------------------------
# Runtime
#
cd %{runtime}-%{runtimeVer}
make prefix=${RPM_BUILD_ROOT}%{prefix} install
cd ..

echo "%%defattr(-,root,root)" > %{runtime}.files
(find ${RPM_BUILD_ROOT}%{prefix}/bin ${RPM_BUILD_ROOT}%{prefix}/include \
	-type f -o -type l;
 find ${RPM_BUILD_ROOT}%{prefix}/lib/*) | cat - *.files \
	| sort | uniq -u >> %{runtime}.files

rm -rf ${RPM_BUILD_ROOT}%{prefix}/{doc,man}

#------------------------------------------
# Win32 API
#
cd %{w32api}-%{w32apiVer}
make prefix=${RPM_BUILD_ROOT}%{prefix} install
cd ..

echo "%%defattr(-,root,root)" > %{w32api}.files
(find ${RPM_BUILD_ROOT}%{prefix}/bin ${RPM_BUILD_ROOT}%{prefix}/include \
	-type f -o -type l;
 find ${RPM_BUILD_ROOT}%{prefix}/lib/*) | cat - *.files \
	| sort | uniq -u >> %{w32api}.files

set +x +H
for n in `cat %{w32api}.files`; do
	test -f $n || continue
	head -1 $n | grep -q ^#! || continue
	chmod u+w $n
	perl -pi -e "s|${RPM_BUILD_ROOT}||" $n
done
set -x -H

#------------------------------------------
# post process the *.files list, removing build sys references and mark
# which are directories

set +x
for n in *.files; do
	mv $n $n.in
	sed "s|.*${RPM_BUILD_ROOT}%{prefix}\\>|%{prefix}|" < $n.in | while read file; do
	    if [ -d ${RPM_BUILD_ROOT}/$file ]; then
		echo -n '%dir '
	    fi
	    echo $file
	done > $n
	rm -f $n.in
done
set -x

#==========================================
%clean
rm -rf ${RPM_BUILD_ROOT}
rm -f *.files

%files -f %{runtime}.files -n %{runtime}
%files -f %{w32api}.files  -n %{w32api_pkg}

%changelog
* Sat Jan 26 2008 Hans Leidekker <hans@it.vu.nl>                3.14.23hl
- update w32api to 3.11
- update runtime to 3.14
- add patches from Stefan Leichter and me
- rebuild on Fedora Core 8

* Thu Jul 12 2007 Hans Leidekker <hans@it.vu.nl>                3.12.22hl
- more patches by Stefan Leichter, John Klehm and me
  to fix building Wine tests

* Tue May 30 2007 Hans Leidekker <hans@it.vu.nl>                3.12.21hl
- update w32api to 3.9
- update runtime to 3.12
- rebuild on Fedora Core 7
- more patches by Stefan Leichter and me to fix building Wine tests

* Sun Jan 14 2007 Hans Leidekker <hans@it.vu.nl>                3.9.20hl
- add more patches to fix building Wine tests

* Thu Dec 28 2006 Hans Leidekker <hans@it.vu.nl>                3.9-19hl
- update w32api to 3.8
- add more patches to fix building Wine tests
- remove patches made obsolete by upstream progress
- rebuild on Fedora Core 6

* Sat Sep 09 2006 Hans Leidekker <hans@it.vu.nl>                3.9-18hl
- add many more patches from Stefan Leichter.
- rebuild on Fedora Core 6 test 2

* Sat Mar 04 2006 Hans Leidekker <hans@it.vu.nl>                3.9-17hl
- update w32api to 3.6
- update runtime to 3.9
- add many patches from Stefan Leichter.

* Fri Nov 18 2005 Hans Leidekker <hans@it.vu.nl>                3.7-16hl
- update w32api to 3.5
- add patches from Stefan Leichter.
- add a patch from Huw Davies.

* Fri Aug 12 2005 Hans Leidekker <hans@it.vu.nl>                3.7-15hl
- add crypt32/mshtml/secur32 patches by Stefan Leichter.
- add more crypt32/mshtml/secur32 patches by me.
- rebuild on Fedora Core 4

* Sun May 29 2005 Hans Leidekker <hans@it.vu.nl>                3.7-14hl
- add ole32/crypt32 import library patches by Stefan Leichter.
- rebuild on Fedora Core 4 test 3

* Mon Mar 21 2005 Hans Leidekker <hans@it.vu.nl>                3.7-13hl
- fix msi import lib
- rebuild on Fedora Core 4 test 1

* Thu Feb 17 2005 Hans Leidekker <hans@it.vu.nl>                3.7-12hl
- fix shell32 import lib 

* Mon Jan 24 2005 Hans Leidekker <hans@it.vu.nl>                3.7-11hl
- update mingw-runtime to 3.7
- add advpack import library patch by Stefan Leichter.

* Tue Jan 13 2005 Hans Leidekker <hans@it.vu.nl>                3.6-10hl
- update mingw-runtime to 3.6
- update w32api to 3.2
- add mscms import library.
- add msi import library.
- add a uuid needed by MAPI tests
- rebuild on Fedora Core 3

* Sat Oct 02 2004 Hans Leidekker <hans@it.vu.nl>                3.5-9hl
- workaround for a build problem on Fedora Core 3 Test 2
- update mingw-runtime to 3.5
- update w32api to 3.1
- remove two patches that are no longer needed
- add two new patches
- rebuild on Fedora Core 3 Test 2

* Sat Aug 07 2004 Hans Leidekker <hans@it.vu.nl>                3.2-8hl
- remove dxguids patch to w32api
- add mlang uuids patch to w32api
- update mingw-runtime to 3.3
- remove 2 patches to runtime accepted upstream 
- rebuild on Fedora Core 3 Test 1

* Fri Apr 16 2004 Hans Leidekker <hans@it.vu.nl>                3.2-7hl
- add Filip Navara's DirectX patches
- gzip the patches

* Tue Mar 31 2004 Hans Leidekker <hans@it.vu.nl>		3.2-6hl
- patches for compiling Wine dlls
- rebuild on Fedora Core 2 Test 2

* Thu Feb 27 2004 Hans Leidekker <hans@it.vu.nl>		3.2-5hl
- apply a workaround for the circular build dependency

* Thu Feb 26 2004 Hans Leidekker <hans@it.vu.nl>		3.2-4hl
- add BuildPrereq: mingw-runtime, mingw-w32api

* Sun Feb 22 2004 Hans Leidekker <hans@it.vu.nl>		3.2-3hl
- don't build debuginfo packages
- rebuild on Fedora Core 2 test 1
- update w32api -> 2.5
- patches for compiling Wine tests 

* Wed Dec 24 2003 Fuhito Suguri <bitwalk@jcom.home.ne.jp>	3.2-2bw
- update mingw-runtime 3.2
- build on Fedora Core 1

* Sat Sep 16 2003 Fuhito Suguri <bitwalk@jcom.home.ne.jp>	3.1-1bw
- update mingw-runtime 3.1
- update w32api 2.4

* Sat May 10 2003 Fuhito Suguri <bitwalk@jcom.home.ne.jp>	10bw
- update mingw-runtime 3.0

* Wed Apr 02 2003 Fuhito Suguri <bitwalk@jcom.home.ne.jp>	9bw
- update w32api 2.3

* Sun Feb 10 2003 Fuhito Suguri <bitwalk@jcom.home.ne.jp>	8bw
- update w32api 2.2

* Sun Feb 09 2003 Fuhito Suguri <bitwalk@jcom.home.ne.jp>	7bw
- update mingw-runtime 2.4

* Sat Dec 21 2002 Fuhito Suguri <bitwalk@jcom.home.ne.jp>	6bw
- update mingw-runtime 2.3

* Fri Nov 24 2002 Fuhito Suguri <bitwalk@jcom.home.ne.jp>	5bw
- change setting of environment for configure script
- change package name w32api to mingw-w32api

* Fri Nov 24 2002 Fuhito Suguri <bitwalk@jcom.home.ne.jp>	4bw
- update w32api 2.1

* Wed Nov 10 2002 Fuhito Suguri <bitwalk@jcom.home.ne.jp>	3bw
- correct the number of NoSource

* Wed Nov 06 2002 Fuhito Suguri <bitwalk@jcom.home.ne.jp>	2bw
- rebuild on RH80

* Sun Oct 06 2002 Fuhito Suguri <bitwalk@jcom.home.ne.jp>	1bw
- Initial Build
